/*
 * menu.h
 */

/* This is to allow building the menu table, since the compiler is too
 * stupid to initialize a union.
 */

struct init_menu {
    char *comm_text;
    char *comm_opt;
    char *comm_desc;
    char comm_type;
    unsigned char lo_limit;
    unsigned char hi_limit;
    PFI procedure;
	char *help;
};

struct menu {
    char *comm_text;
    char *comm_opt;
    char *comm_desc;
    char comm_type;
    unsigned char lo_limit;
    unsigned char hi_limit;
    union {
	PFI procedure;
	struct menu *menu_p;
    } command;
	char *help;
};

    /* Required menus */
extern struct init_menu i_global_comm [];
extern struct init_menu i_boot_level [];
extern struct menu *global_comm;
extern struct menu *boot_level;

    /* Include the local menus */
#include "localmenu.h"

#define MENUSTACKSIZE 16

struct mstack {
    struct menu *m_ptr;
    char *name;
};

extern struct mstack menu_stack [];
extern int menu_ptr;

