/*DO NOT EDIT THIS FILE! EDIT spm.h.doc INSTEAD!!!*/
#define PROMSIZ    0x10000           /* cpu monitor prom*/
#define PROMSTART  0x00000000        /* start of prom area */
#define SRAMSTART 0x01000000
#define SRAMSIZE  0x40000
#define NOVRAM	((struct novram *)(0x03000000))
#define NEW_NOVRAM	((struct new_novram *)(0x03000000))
#define RTC ((struct rtc *)(0x030007f8))
#define ADC_CNTL ((unsigned short*)(0x02800102)) 
#define ADC_ADATA ((unsigned short*)(0x02800100))
#define ADC_SC    0x0100
#define ADC_CH0   0x0000        /* measures +5v for master system */
#define ADC_CH1   0x0001        /* reference voltage 4.5v must read FF */
#define ADC_CH2   0x0002        /* Measure +5v. aux */
#define ADC_CH3   0x0003        /* Measure +12v */
#define ADC_CH4   0x0004        /* Measure +12v aux */
#define ADC_CH5   0x0005        /* Measure -12v */
#define ADC_CH6   0x000e        /* Measure -12v aux */
#define ADC_CH7   0x000f        /* measure on board temperature. */
#define ADC_EOC   0x8000 
#define ADC_MASK  0x00ff        /* mask for valid data. */
#define LOCCIO ((struct cio *)(0x02800200))
#define ASCC ((struct ascc *)(0x02800800))
#define AUXASCC0B ((struct ascc *)(0x02800800))
#define AUXASCC0A ((struct ascc *)(0x02800820))
#define AUXASCC1B ((struct ascc *)(0x02800900))
#define AUXASCC1A ((struct ascc *)(0x02800920))
#define CLKCNTL  ((unsigned *)(0x05000000))
#define CSSCMD ((unsigned *)(0x07000080))
#define STATUSREG ((unsigned *)(0x070000a0))
#define STAT_SLOTMASK  0x0f000000
#define STAT_SLOTSH    24
#define STAT_REG_IDRAM 0x80000000
#define STAT_IDLE_FULL 0x10000000		/* If set, idle-que is not full. */
#define STAT_FLOP_RDY 0x40000000		/* Mask for floppy ready. */
#define CSSERROR    ((unsigned *)(0x070000c0))
#define DERR        15
#define SERR        14
#define BTYPE_SH    8
#define SRC_SH      16
#define DEST_SH     20
#define BPAR_SH     24
#define BPAR_MASK   0x01000000
#define DEST_MASK   0x00f00000
#define SRC_MASK    0x000f0000
#define BTYPE_MASK  0x00003f00
#define TYPE_SH     0x0b
#define TYPE_MASK   0x3800
#define SIZE_MASK   0x0700
#define SIZE_SH     0x08
#define DISPERROR     ((unsigned *)(0x070000e0))
#define DISP_ACK_ERR       1        /* insane ack, an ack for no good reason */
#define DISP_REQ_ERR       2        /* request with no int. pending */
#define DISP_ACK_TOUT      5        /* timeout on ack response */
#define DISP_REQ_TOUT      6        /* timeout on request */
#define DISP_RCV_ERR       7
#define DISP_ERR_SH        20
#define WRCNTL0 ((unsigned *)(0x07000000))
#define WR0_FTYPE_MASK    0x0000003f
#define WR0_FADD01_MASK   0x000000c0
#define WR0_FADD01_SH     0x06
#define WR0_PRETEND_MASK  0x0000f000
#define WR0_PRETEND_SH    12 
#define WR0_FRC_ACK       0x01000000
#define WR0_FRC_GRANT     0x02000000
#define WR0_FRC_DEST      0x04000000
#define WR0_FRC_FREE      0x08000000
#define WR0_FRC_INH7      0x10000000
#define WRCNTL1 ((unsigned *)(0x07000020))
#define WR1_DIAG_ANY_TYPE    0x04000000
#define WR1_FRC_RST_ACK      0x80000000
#define WR1_IRDY             0x40000000        
#define WR1_RRDY             0x20000000
#define WR1_FMOD             0x10000000
#define WR1_FDEST            0x08000000
#define WR1_DATYPE           0x04000000
#define WR1_FINTREC          0x02000000
#define WR1_DREQ             0x01000000
#define WR1_CSSRST           0x00800000
#define WR1_IDLERST          0x00400000
#define WR1_FRC_RST_RCV      0x00200000
#define WR1_RSTREC           0x00200000
#define WR1_TPOL             0x00100000
#define WR1_UFTYPE           0x00080000
#define WR1_ID_RST           0x00040000
#define WR1_CSSRD_MASK       0x00030000
#define WR1_32BYTE_RD        0x00030000
#define WR1_RD32             0x00030000
#define WR1_16BYTE_RD        0x00020000
#define WR1_RD16             0x00020000
#define WR1_8BYTE_RD         0x00010000
#define WR1_RD8              0x00010000
#define WR1_4BYTE_RD         0x00000000
#define WR1_MOTOR            0x00008000
#define WR1_FDACK            0x00004000
#define WR1_FRES             0x00002000
#define WR1_TP               0x00001000
#define WR1_DEST_SH          8
#define WR1_POL              0x000000ff
#define WRCNTL2 ((unsigned char *)(0x07000040))
#define WR2_BDRST 0x80
#define WR2_LED0 0x40
#define WR2_LED1 0x20
#define WR2_GRNLED 0x10
#define WR2_REDLED 0x08
#define WR2_LED01_SH 0x05
#define	NUM_CSS_MAPS	8
#define MAPBASE (unsigned char *)0x08000000
#define MAP0    (unsigned char *)0x08000000
#define MAP1    (unsigned char *)0x18000000
#define MAP2    (unsigned char *)0x28000000
#define MAP3    (unsigned char *)0x38000000
#define MAP4    (unsigned char *)0x48000000
#define MAP5    (unsigned char *)0x58000000
#define MAP6    (unsigned char *)0x68000000
#define MAP7    (unsigned char *)0x78000000
#define IDLEREG     (unsigned int *)0x0b000000
#define IDLESHFT    24
#define QUEUE_RAM (unsigned *)(0x0c000000)
#define QUEUE_LEN     0x4000
#define QUEUE_LWORDS  0x1000
#define VECTOR_MASK   0xff000000
#define VECTOR_SH     24 
#define Q_DEST_MASK   0x0000f000
#define Q_DEST_SH     12
#define Q_SRC_MASK    0x00000f00
#define Q_SRC_SH      8
#define POINTER_RAM (unsigned *)(0x0d000000)
#define POINTER_LEN             0x100
#define POINTER_LWORDS          0x40 
#define POINTER_MASK            0x7f7f0000
#define OUT_PNTR_SH             16
#define IN_PNTR_SH              24
#define MISC_RAM (unsigned *)(0x0e000000)
#define MISC_LEN            0x200
#define MISC_LWORDS         0x80
#define MISC_MASK           0x0f0083ff
#define CNTR_MASK           0x000003ff
#define CNTR_LWORDS         8
#define CNTR_ZERO_BIT       0x00000400
#define SERV_MASK           0x00008000
#define SERV_LWORDS         0x60
#define CONFIG_LWORDS       16
#define CONFIG_MASK         0x0f000000
#define CONFIG_SH           24
#define PIPEDATA (unsigned *)(0x80000018)
#define PIPEADDR (unsigned *)(0x8000001c)
#define DATARESP 4
#define MAX_CSS_SLOT 16
